// Initial code obtained from http://www.karakas-online.de/myServices/wheel.html
// Code has been modified and additional code added by ShopSite, Inc.
!(function(){
	"use_strict";
	var mouseColor, selectedColor, wheelDiv, mouseOverWheel;
	//Functions for browser compatability: addEvent, getById, and getData
	var addEvent=document.addEventListener?function(e,n,t,o){return e.addEventListener(n,t,!!o),t}:document.attachEvent?function(e,n,t){n="on"+n;function o(){return t.apply(e,arguments)}return e.attachEvent(n,o),o}:function(e,n,t){n="on"+n,e.memoize=e.memoize||{},e.memoize[n]||(e.memoize[n]={counter:1},e[n]=function(){for(var n in o)o.hasOwnProperty(n)&&"function"==typeof o[n]&&o[n].apply(this,arguments)});var o=e.memoize[n],n=o.counter++;return o[n]=t,n},getById=function(e,o){var l=o?o.document:document;return l.getElementById?l.getElementById(e):l.all?l.all[e]:null},getData=function(t,e){if(t.dataset)return t.dataset[e];if(t.getAttribute){var a="data-"+e.replace(/[A-Z]/g,"-$&").toLowerCase();return t.getAttribute(a)}for(var r="data-"+e.replace(/[A-Z]/g,"-$&").toLowerCase(),n=t.attributes,u=0;u<n.length;u++)if(n[u].nodeName===r)return n[u].nodeValue;return null};

	addEvent(window, 'load', function(e){
		var colorWheel = getById("colorwheel");
		addEvent(colorWheel, 'mouseover', function(e){mouseOverWheel=true});
		addEvent(colorWheel, 'mouseout', function(e){mouseOverWheel=false});
		addEvent(colorWheel, 'click', function(e){select_color()});
		addEvent(getById('button_apply_sm'), 'click', apply_color);
		addEvent(getById('button_close_sm'), 'click', function(e){window.close()});
		wheelDiv = getById("wheel");
		addEvent(wheelDiv, 'mousemove', mouseMoved);
		mouseColor = getById("mouseColor");
		selectedColor = getById("selectedColor");
		select_color(selectedColor.value);
		window.focus();
	});

	var mouseMoved=(function(){
		var clrary=(function(){
			var addary = new Array(), clrary = new Array(360);
			addary[0] = [0,1,0];   // red
			addary[1] = [-1,0,0];  // red green
			addary[2] = [0,0,1];   // green
			addary[3] = [0,-1,0];  // green blue
			addary[4] = [1,0,0];   // blue
			addary[5] = [0,0,-1];  // red blue
			addary[6] = [255,1,1]; // red

			for (i = 0; i < 6; i++)
			{
				for (j = 0; j < 60; j++)
				{
					clrary[60 * i + j] = new Array(3);
					for (k = 0; k < 3; k++)
					{
						clrary[60 * i + j][k] = addary[6][k];
						addary[6][k] += (addary[i][k] * 4);
					}
				}
			}
			return clrary;
		})();
		return function (e)
		{
			var x,y,sx,sy,qx,qy,quad,xa,ya,d,deg,n,r,c,fg;
			if (!mouseOverWheel)
				return false;

			if (document.getElementById)
			{
				x = 4 * e.offsetX;
				y = 4 * e.offsetY;
			}
			else if (document.all)
			{
				x = 4 * event.offsetX;
				y = 4 * event.offsetY;
			}

			sx = x - 512;
			sy = y - 512;
			qx = (sx < 0)?0:1;
			qy = (sy < 0)?0:1;
			q = 2 * qy + qx;
			quad = [-180,360,180,0];
			xa = Math.abs(sx);
			ya = Math.abs(sy);
			d = ya * 45 / xa;
			if (ya > xa)
				d = 90 - (xa * 45 / ya);

			deg = Math.floor(Math.abs(quad[q] - d));
			n = 0;
			sx = Math.abs(x - 512);
			sy = Math.abs(y - 512);
			r = Math.sqrt((sx * sx) + (sy * sy));
			if (x == 512 && y == 512)
				c = "000000";
			else
			{
				for (i = 0; i < 3; i++)
				{
					var r2 = clrary[deg][i] * r / 256;

					if (r > 256)
						r2 += Math.floor(r - 256);

					if (r2 > 255)
						r2 = 255;

					n = 256 * n + Math.floor(r2);
				}

				c = n.toString(16);

				while (c.length < 6)
					c = "0" + c;

				c = "#" + c.toUpperCase();
			}

			fg = fgcolor(c);

			mouseColor.style.backgroundColor = c;
			mouseColor.style.color = fg;
			mouseColor.value = c;

			return false;
		}
	})();

	function select_color(color)
	{
		if (!color)
			color = mouseColor.value;
		selectedColor.value = color;
		selectedColor.style.backgroundColor = color;
		selectedColor.style.color = fgcolor(color);
	}

	function apply_color(e)
	{
		var colorName = getData(getById('button_apply_sm'), 'colorName');
		var color, inputobj, showcolor;
		e.preventDefault();

		inputobj = getById(colorName, window.opener);
		showcolor = getById('show_' + colorName, window.opener);

		color = selectedColor.value;
		showcolor.style.backgroundColor = color;
		inputobj.value = color;
		if(typeof inputobj.onchange == 'function')inputobj.onchange();
	}

	// Adapted from: https://awik.io/determine-color-bright-dark-using-javascript/
	function fgcolor(color) {
		var r, g, b, hsp;

		// If hex --> Convert it to RGB: http://gist.github.com/983661
		color = +("0x" + color.slice(1).replace(color.length < 5 && /./g, '$&$&'));

		r = color >> 16;
		g = color >> 8 & 255;
		b = color & 255;

		// HSP equation from http://alienryderflex.com/hsp.html
		hsp = Math.sqrt(
				0.299 * (r * r) + // 30% Red
				0.587 * (g * g) + // 59% Green
				0.114 * (b * b)   // 11% Blue
		);

		// Using the HSP value, determine whether the color is light or dark
		if (hsp>127.5) {
			return 'black';
		} else {
			return 'white';
		}
	}
})();
