"use_strict";
const ss_upload={};
$(function($){
	ss_upload.parms=$('form#mediam').serializeArray();
	ss_upload.parms.push({name:'ajax_upload',value:'checked'});
	ss_upload.index=0;
	ss_upload.total=0;
  $('form#mediam').submit(function(e){e.preventDefault();are_files_selected()&&start_upload();});
  $('input#uploadFile').change(function(e){handleFiles(this.files)});
});

//Drag-and-drop based off of: https://www.smashingmagazine.com/2018/01/drag-drop-file-uploader-vanilla-js/
let allFiles=[],d=document,dropArea=d.getElementById('drop-area'),ulFiles=d.getElementById('upload-files-div');
['dragenter', 'dragover', 'dragleave', 'drop'].forEach(eventName => {dropArea.addEventListener(eventName, preventDefaults, false)});
function preventDefaults (e) {e.preventDefault();e.stopPropagation();}
['dragenter', 'dragover'].forEach(eventName => {dropArea.addEventListener(eventName, highlight, false)});
['dragleave', 'drop'].forEach(eventName => {dropArea.addEventListener(eventName, unhighlight, false)});
function highlight(e) {dropArea.classList.add('highlight')}
function unhighlight(e) {dropArea.classList.remove('highlight')}
dropArea.addEventListener('drop', handleDrop, false);
function handleDrop(e) {handleFiles(e.dataTransfer.files)}
function handleFiles(files) {
	let errors={ua:[],dp:[]};
	([...files]).forEach((f)=>{let e=add_file(f);if(e.code=='unallowed'){errors.ua.push(e.file)}else if(e.code=='duplicate'){errors.dp.push(e.file)}});
	if(errors.ua.length > 0) {
		let file_names=[];
		errors.ua.forEach((e)=>file_names.push(e));
		alert(unallowed_upload_msg + '\n' + file_names.join('\n'));
	}
	adjustFloater();
}

function add_file(file)
{
	let d=document, file_name = file.name, file_num = allFiles.length, add_file_name, file_ext='', file_type, index, i, html=d.getElementById('file-upload-template').innerText,return_value={},uf;

	if ((index = file_name.lastIndexOf('\\')) < 0)
		index = file_name.lastIndexOf('/');

	if (index > 0)
		file_name = file_name.substr(index + 1);

	if (file_type_permitted(file_name) == false)
	{
		return {code:'unallowed',error:unallowed_upload_msg,file:file_name};
	}

	add_file_name = file_name;

	uf=d.createElement('div');
	uf.id='file-upload-'+file_num;
	uf.className='file-upload ajax';
	uf.innerHTML=html.replace(/XX/g,file_num);
	ulFiles.appendChild(uf);
	let save_as = d.getElementById('saveas_'+file_num);
	if (unallowed_filename_chars(file_name))
	{
		if ((index = file_name.lastIndexOf('.')) >= 0)
		{
			file_ext = file_name.substr(index+1);
			file_name = file_name.substr(0, index);
		}
		save_as.value = file_name = trim_filename(file_name);
	}
	else
	{
		if ((index = file_name.lastIndexOf('.')) >= 0)
		{
			file_ext = file_name.substr(index+1);
			file_name = file_name.substr(0, index);
		}
		save_as.value = '';
	}

	allFiles.forEach((f)=>{
		if (f && f.name && f.name == file_name && f.ext == file_ext)
		{
			f.element.classList.add('check_name');
			uf.classList.add('check_name');
			returnValue = {code:'duplicate',error:txt_dup1 + '  ' + txt_dup2,file:file_name};
		}
	});

	allFiles.push({file:file,
		file_name:add_file_name,
		name:file_name,
		ext:file_ext,
		num:file_num,
		element:uf
	});

	uf.querySelector('.file-name').innerText=add_file_name;

	let image = $('img.preview-image', uf);
	if(image.length) {
		let reader = new FileReader();
		image.data('type',file.type);
		reader.onload = function(e){load_preview_image(image, e.target.result)};
		reader.readAsDataURL(file);
	}
	return return_value;
}

function remove_upload(el)
{
	let fnum = parseInt(el.id.replace('remove_','')),file=allFiles[fnum],uf=file.element;
	uf.remove();
	allFiles[fnum]=null;
}
$(document).on('click', 'input.button.remove', function(e){
	e.preventDefault();
	remove_upload(this);
});

function are_files_selected()
{
	let num = 0;
	allFiles.forEach((e)=>num+=e&&1||0);
	if( num == 0 )
	{
		alert(txt_select_files);
		return false;
	}
	return true;
}

function check_for_duplicates(show_alert)
{
	let file_names={}, check=false;
	$('div.check_name').removeClass('check_name');
	allFiles.forEach(function(f){
		if(f){
			let r=f.name+'.'+f.ext,l=file_names[r]||[];
			l.push(f.element);
			file_names[r]=l;
		}
	});
	for(a in file_names){if(file_names[a].length>1){file_names[a].forEach(b=>b.classList.add('check_name'),check=true)}};
	if(show_alert&&check){check=!confirm(txt_dup1 + '  ' + txt_dup2 + '\n\n' + txt_dup3);}
	return !check;
}

function check_saveas(save_as)
{
	var file_name = trim_filename(save_as.value),file_num=parseInt(save_as.id.replace('saveas_','')),file=allFiles[file_num];
	save_as.value = file_name;
	if(file_name){
		file.name=file_name;
	}
	else{
		file_name=parse_file_name(file);
		if(unallowed_filename_chars(file.file_name)){
			file_name=save_as.value=trim_filename(file_name)
		}
	}
	check_for_duplicates(false);

	if (unallowed_filename_chars(file_name))
	{
		$('#allowed_chars').show();
		save_as.classList.add('error');
		save_as.focus();
		return false;
	}

	save_as.classList.remove('error');
	return true;
}

function remove_unallowed_chars()
{
	document.querySelectorAll('#upload-files-div > div.file-upload').forEach((f)=>{
		let save_as = f.querySelector('.saveas');
		save_as.value = trim_filename(save_as.value);
		save_as.classList.remove('error');
	});

	$('#allowed_chars').hide()
}

// Adpted from https://stackoverflow.com/questions/166221/how-can-i-upload-files-asynchronously

function set_status(e,name){(e)&&(e.text(e.data(name)))}
function next_file()
{
	if(ss_upload.index < allFiles.length){
		let f=allFiles[ss_upload.index++];
		while(f==null&&(ss_upload.index < allFiles.length))f=allFiles[ss_upload.index++];
		return f;
	}else{return null}
}
function send_files(url,parms)
{
	let file=next_file();
	if(file){
		var formData=new FormData(),e,num=file.num;
		parms.forEach((p)=>{formData.append(p.name,p.value)});
		formData.append('saveas',$('input.saveas',file.element).val());
		(e=file.element.querySelector('.desc'))&&formData.append('desc',e.value);
		(e=file.element.querySelector('.rotate'))&&formData.append('rotate',e.value);
		formData.append('Filename', file.file);
		set_status($('span.status',file.modal), 'uploading');
		$.ajax({
			url:url,
			data:formData,
			cache:false,
			contentType:false,
			processData:false,
			method:'POST',
			success:function(data){
				let i=$('img',file.modal);
				i.attr('src',i.data('greenck'));
				file.finished=true;
				ss_upload.total++;
				set_status($('span.status',file.modal), 'done');
				send_files(url, parms);
			},
			error:function(e){
				let i=$('img',file.modal);
				i.attr('src',i.data('redx'));
				ss_upload.total++;
				set_status($('span.status',file.modal), 'failed');
				send_files(url, parms);
			},
			xhr: function(){
				let x=$.ajaxSettings.xhr();
				if(x.upload){
					x.upload.addEventListener('progress', function(e){
						if(e.lengthComputable){
							$('progress',file.modal).attr({value:e.loaded,max:e.total});
							if(e.loaded == e.total){set_status($('span.status',file.modal), 'processing')}
						}
					});
				}
				return x;
			}
		});
	}
}

function start_upload()
{
	let bad_file = false, save_id=[], save_as, file_name;
	ss_upload.files=0;
	ss_upload.total=0;
	ss_upload.index=0;
	// Alert user if any file types are not permitted for uploading.
	allFiles.forEach(f=>{if(f&&!file_type_permitted(f.file_name)){f.element.classList.add('error');bad_file=true;}else if(f){ss_upload.files++}});
	if (bad_file)
	{
		alert(unallowed_upload_msg);
		return false;
	}

	// Alert user if any save_as file names have unallowed characters.
	document.querySelectorAll('input.saveas').forEach(save_as => {
		let i=parseInt(save_as.id.replace(/saveas_/,'')),file=allFiles[i];
		file_name = save_as.value;
		if (file_name.length > 0 && unallowed_filename_chars(file_name))
		{
			save_id.push(save_as);
		}
		else if(file_name.length == 0 && unallowed_filename_chars(file_name=file.file_name))
		{
			file_name=parse_file_name(file);
			save_as.value=trim_filename(file_name);
			save_id.push(save_as);
		}
	});
	if(save_id.length > 0){
		save_id.forEach(e=>$(e).closest('div.file-upload').addClass('check_name'));
		alert(unallowed_chars_msg);
		save_id[0].focus();
		return false;
	}
	if(check_for_duplicates(true))
	{
		let form=document.getElementById('mediam'),url=form.action,parms=[],template=document.getElementById('uploading-template').innerText,modal,uploadParms=ss_upload.parms;
		$(template).appendTo('body').wrap('<div id="modal-overlay"></div>').wrap('<div id="modal-content"></div>');
		modal=document.getElementById('uploading');
		template = document.getElementById('uploading-file-template').innerText;
		allFiles.forEach(function(f){
			if(f){
				let file=$(template.replace(/XX/g,f.num)).appendTo(modal);
				$('.upload-file-name', file).text(f.name+'.'+f.ext);
				f.modal=file;
			}
		});
		$('div.floater').hide();
		if(form.resize_on_upload){uploadParms.push({name:'resize_on_upload','value':form.resize_on_upload.checked&&'checked'||null})}
		uploadParms.push({name:'upload.x',value:'Upload'});
		document.querySelector('#button_done').onclick=function(e){
			if(ss_upload.total < ss_upload.files){!confirm(upload_not_finished_txt)&&e.preventDefault()}
		};
		for(var i=0;i<num_simultaneous_uploads;i++){
			send_files(url,uploadParms);
		}
	}
	return false;
}

function file_type_permitted(file_name)
{
	var file_type;
	var bOk = true;
	var i;

	if ((i = file_name.lastIndexOf('.')) >= 0)
	{
		file_type = file_name.substr(i + 1);
		bOk = file_type.toLowerCase() != 'php';
	}

	return bOk;
}

function resize_default()
{
	if (resize_enabled == false)
	{
		alert(resize_msg);
		document.getElementById('resize').checked = false;
	}
}

function parse_file_name(file)
{
	let file_name=file.file_name,index;
	if ((index = file_name.lastIndexOf('.')) >= 0)
	{
		file.ext = file_name.substr(index+1);
		file.name = file_name.substr(0, index);
	}
	else
	{
		file.ext='';
		file.name=file_name;
	}
	return file.name;
}
