"use_strict";
$(function($){
	$('label.file-input input.hidden').change(function(e){add_file(this)});
});
function add_file(file)
{
	let file_name = file.value,save_as = document.getElementById('fname'),index,parent=file.parentElement,image;

	if ((index = file_name.lastIndexOf('\\')) < 0)
		index = file_name.lastIndexOf('/');

	if (index > 0)
		file_name = file_name.substr(index + 1);

	if (file_type_permitted(file_name))
	{
		if (unallowed_filename_chars(file_name))
		{
			if ((index = file_name.lastIndexOf('.')) >= 0)
				file_name = file_name.substr(0, index);

			save_as.value = file_name.replace(/[^a-zA-Z0-9\-._]/g, '-');
		}
		else
			save_as.value = '';
	}
	else
	{
		alert(unallowed_upload_msg);
		file.focus();
		return false;
	}
	image = $('img.preview-image', parent.parentElement);
	if(file.files && file.files[0]) {
		let reader = new FileReader();
		image.data('type',file.files[0].type);
		reader.onload = function(e){load_preview_image(image, e.target.result)};
		reader.readAsDataURL(file.files[0]);
	}
	parent.querySelector('span.file-input-name').innerText=file_name;
}

function check_saveas(save_as)
{
	var filename = trim_filename(save_as.value);
	save_as.value = filename;

	if (unallowed_filename_chars(filename))
	{
		var allowed_chars = document.getElementById('allowed_chars');
		allowed_chars.style.display = '';
		save_as.style.borderColor = 'red';
		save_as.focus();
		return false;
	}

	save_as.style.borderColor = '';
	return true;
}

function remove_unallowed_chars()
{
	var save_as = document.getElementById('fname');
	var allowed_chars = document.getElementById('allowed_chars');

	save_as.value = save_as.value.replace(/[^a-zA-Z0-9\-._]/g, '-');
	save_as.style.borderColor = '';

	allowed_chars.style.display = 'none';
}

function start_upload()
{
	var userfile = document.getElementById('userfile');
	var save_as = document.getElementById('fname');

	if (userfile.value.length == 0)
	{
		alert(enter_file_name);
		userfile.focus();
		return false;
	}

	if (file_type_permitted(userfile.value) == false)
	{
		alert(unallowed_upload_msg);
		userfile.focus();
		return false;
	}

	if (unallowed_filename_chars(save_as.value))
	{
		save_as.focus();
		alert(unallowed_chars_msg);
		return false;
	}

	ss_loadmask('on');
	return true;
}

function file_type_permitted(file_name)
{
	var file_type;
	var bOk = true;
	var i;

	if ((i = file_name.lastIndexOf('.')) >= 0)
	{
		file_type = file_name.substr(i + 1);
		bOk = file_type.toLowerCase() != 'php';
	}

	return bOk;
}
$(document).on('click', 'label.file-input label.button', function(e){e.target.parentElement.click()});
