"use_strict";
function form_element(element_id){return document.getElementById(element_id);}
function check_radio_button(id, num){$('#'+id+'_'+num).prop('checked', true);}
function remove_quotes(value){return value.replace(/"/g, '');}

function update_image_alt(image)
{
	var size;
	for (size = 0; size < 4; size++)
	{
		if (form_element(image + ':url_' + size) != null)
			update_image_tag(image, size);
	}
}

function update_image_tag(image, size)
{
	var url, alt, width, height, border, vspace, hspace, other;
	var field, id, tag;

	url = form_element(image + ':url_' + size).value;
	/*
	width = form_element(image + ':width_' + size).value;
	height = form_element(image + ':height_' + size).value;
	border = form_element(image + ':border_' + size).value;
	vspace = form_element(image + ':vspace_' + size).value;
	hspace = form_element(image + ':hspace_' + size).value;
	*/
	other = form_element(image + ':other_' + size).value;
	field = form_element(image + ':alt_0');
	alt = remove_quotes(field.value);
	field.value = alt;

	/*
	tag = '<img src="' + url + '"';

	if (alt.length > 0)
		tag += ' alt="' + alt + '"';

	if (width.length > 0)
	tag += ' width="' + width + '"';

	if (height.length > 0)
	tag += ' height="' + height + '"';

	if (border.length > 0)
	tag += ' border="' + border + '"';

	if (vspace.length > 0)
	tag += ' vspace="' + vspace + '"';

	if (hspace.length > 0)
	tag += ' hspace="' + hspace + '"';

	if (other.length > 0)
		tag += ' ' + other;
	*/
	tag=document.createElement('img');
	tag.src=url;
	tag.alt=alt;

	form_element(image + ':image_tag_' + size).value = tag.outerHTML;
}

function check_resize_percent(image)
{
	var id, resize_percent;

	resize_percent = form_element(image + ':image_resize_percent');

	if (!resize_percent.disabled)
	{
		if (resize_percent.value > 100)
		{
			alert(images_cannot_be_made_larger);
			resize_percent.value = 100;
			resize_percent.focus();
			return false;
		}
	}

	return true;
}

function check_resize_dimensions(image)
{
	var image_width, image_height;
	var image_resize_width, image_resize_height;
	var id;

	image_width = form_element(image + ':image_width');

	image_height = form_element(image + ':image_height');

	image_resize_width = form_element(image + ':image_resize_width');

	image_resize_height = form_element(image + ':image_resize_height');

	if (!image_resize_width.disabled)
	{
		if (Number(image_resize_width.value) > Math.max(Number(image_width.value), 0))
		{
			alert(images_cannot_be_made_larger);
			image_resize_width.value = image_width.value;
			image_resize_width.focus();
			return false;
		}

		if (Number(image_resize_height.value) > Math.max(Number(image_height.value), 0))
		{
			alert(images_cannot_be_made_larger);
			image_resize_height.value = image_height.value;
			image_resize_height.focus();
			return false;
		}
	}

	return true;
}

function validate(nimages)
{
	var image, image_name, rename_to, alt;
	var renaming = false;
	var id;

	for (image = 0; image < nimages; image++)
	{
		alt = form_element(image + ':alt_0');
		alt.value = remove_quotes(alt.value);
	}

	for (image = 0; image < nimages; image++)
	{
		if (check_resize_percent(image) == false)
			return false;

		if (check_resize_dimensions(image) == false)
			return false;
	}

	for (image = 0; image < nimages; image++)
	{
		rename_to = form_element(image + ':image_rename_to');

		if (check_filename(rename_to) == false)
		{
			rename_to.focus();
			return false;
		}

		image_name = form_element(image + ':image_name').value;
		if ((i = image_name.lastIndexOf('.')) > 0)
			image_name = image_name.slice(0, i);

		if (image_name != rename_to.value)
			renaming = true;
	}

	if (renaming)
		return confirm_rename();
	else
		return true;
}

function check_filename(filename)
{
	if (filename.value.match(/[^a-zA-Z0-9\-._]/g) != null)
	{
		alert(enter_valid_file_name + '  ' + valid_file_name_chars);
		filename.focus();
		return false;
	}

	if (filename.value.charAt(0) == '.')
	{
		alert(cannot_begin_with_dot);
		filename.focus();
		return false;
	}

	return true;
}

function confirm_rename(){return confirm(confirm_rename_msg);}

$(function(){
	$('img.preview-image').each(function(){
		let image=$(this), id=parseInt(image.parent().find('input.rotate').attr('name').replace(/:.*$/,'')), url=form_element(id+':url_0').value, t=url.match(/\.(jpg|jpeg|png|gif)$/), r=document.querySelector('#noresize-'+id);
		if(!r&&t&&t.length==2){image.data('type','image/'+t[1].replace('jpg','jpeg'))}
		load_preview_image(image, url);
	});
});
