// Functions for creating and renaming media directories
function set_focus(field_id){document.getElementById(field_id).focus()}

function enter_key_pressed(e)
{
  if (e == undefined)
    e = window.event;
  
  if (e != undefined)
  {
    if (e.keyCode == 13)
    {
      var dirname = document.getElementById('dirname');

      if (check_dirname(dirname, null))
        do_media_directory();
      else
        return false;
    }
  }
}

function check_dirname(dirname, newname)
{
  var parts = media_path.split(gsSlash);
  var not_allowed = false;

  if (newname != null) // renaming vs. creating a directory
  {
    if (newname.value.length == 0)
    {
      alert(cf_msg7);
      newname.focus();
      return false;
    }
    
    dirname = newname;
  }

  if (dirname.value.length > 0)
  {
    if (dirname.value.match(/[^a-zA-Z0-9\-._]/g) != null)
    {
      var msg = cf_msg1 + '\n';
      msg += cf_msg2 + '  ';
      msg += cf_msg3 + '\n';
      
      alert(msg);
      dirname.focus();
      return false;
    }

    if (dirname.value.charAt(0) == '.')
    {
      alert(cf_msg4);
      dirname.focus();
      return false;
    }

    if (parts[0] == 'media')
    {
      if (dirname.value == 'media')
      {
        if (newname != null)  // renaming
          not_allowed = parts.length <= 2;
        else
          not_allowed = parts.length < 2;
      }
    }
    
    if (not_allowed)
    {
      alert(cf_msg5);
      dirname.focus();
      return false;
    }
  }

  return true;
}

function do_media_directory()
{
  var dirname = document.getElementById('dirname');
  var newname = document.getElementById('newname');

  if (check_dirname(dirname, newname))
  {
    var subsystem = document.getElementById('subsystem');
    var form = document.getElementById('mediam');

    var operation = newname != null? '?rename_directory=' : '?create_directory=';
    var url = form.action + operation + encodeURIComponent(dirname.value);

    if (newname != null)
      url += '&newname=' + encodeURIComponent(newname.value);

    url += '&media_path=' + encodeURIComponent(media_path);
    url += '&subsystem=' + subsystem.value;
    url += '&sid=' + Math.random();
    url += '&form_parm1=' + document.getElementById('form_parm1').value;

    xmlHttp = GetXmlHttpObject();
    xmlHttp.onreadystatechange = media_directory_results;
    xmlHttp.open("GET", url, false); // synchronous
    xmlHttp.send(null);
  }
}

function media_directory_results()
{
  if (xmlHttp.readyState == 4 || xmlHttp.readyState == 'complete')
  {
    var response = xmlHttp.responseText;
    var parts = response.split(':');

    if (parts[0] == 'fail')
    {
      var dirname = document.getElementById('dirname');
      var newname = document.getElementById('newname');

      if (newname != null)
        dirname = newname;

      alert(parts[1]);
      dirname.focus();
      return false;
    }
    else
    {
      window.location='mediam.cgi';
    }
  }
}

/*************************************************************************
 *
 * AJAX
 *
 *************************************************************************/

var xmlHttp = null;

function GetXmlHttpObject()
{
  try
  {
    xmlHttp = new XMLHttpRequest();
  }
  catch(e)
  {
    try
    {
      xmlHttp = new ActiveXObject("MSXML2.XMLHTTP");
    }
    catch(e)
    {
      xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
  }

  return xmlHttp;
}

