function upload_domain_validation_file() {
	var file = $('#domain_validation_file').val();
	if (file.length) {
		var options = {
			success: function(responseText, statusText, xhr, $form) {
				$('body').css({cursor: 'default'});
				$('.domain_validation_status').removeClass('red').addClass('green').val(responseText);
			},
			async: false,
			forceSync: true
		}
		$('body').css({cursor: 'progress'});
		$('#domain_validation_file').wrap('<form enctype="multipart/form-data" action="payconfig.cgi?ajax=upload_apple_validation_file&processor='+$('#domain_validation_file').attr('data-processor')+'" method=post></form>');
		$('#domain_validation_file').parent().ajaxSubmit(options);
		$('#domain_validation_file').unwrap();
	}
}

function upload_applepay_cert() {
	var file = $('#applepay_cert').val();
	if (file.length) {
		var options = {
			success: function(responseText, statusText, xhr, $form) {
				$('body').css({cursor: 'default'});
				if (responseText == "Certificate present")
					$('.cert_status').removeClass('red').addClass('green').val(responseText);
				else
					$('.cert_status').removeClass('green').addClass('red').val(responseText);
			},
			async: false,
			forceSync: true
		}
		$('body').css({cursor: 'progress'});
		$('#applepay_cert').wrap('<form enctype="multipart/form-data" action="payconfig.cgi?ajax=upload_applepay_cert" method=post></form>');
		$('#applepay_cert').parent().ajaxSubmit(options);
		$('#applepay_cert').unwrap();
	}
}

function create_csr() {
	if($('input[name=display_name]').hasClass('error')) {
		$('input[name=display_name]').focus();
		alert('Correct the error');
		return false;
	}else
		//First check if they meant to click this and knows it will break ApplePay that already works
	if($('.csr_status').hasClass('red') || confirm('This may break ApplePay.\nContinue?'))
	{
		$.ajax({
			url:'payconfig.cgi',
			data:{'ajax':'create_apple_csr','form_parm1':$('input#form_parm1[type=hidden]').val(),'display_name':$('input[name=display_name]').val().replace(/^\s*|\s*$/g,'')},
			success:
			function(data) {
				if (data == '1') {
					$('.csr_status').removeClass('red').addClass('green').val('Private key present');
					alert('CSR Created Successfully');
				} else {
					$('.csr_status').removeClass('green').addClass('red').val('Private key failed');
					alert('An error has occurred');
				}
			},
			async:false
		});
	}
}

function download_csr() {
	var form = $('<form action="payconfig.cgi" method="GET"></form>');
	form.append($('<input type="hidden" name="ajax" value="download_apple_csr">'));
	form.append($('<input type="hidden" name="form_parm1">').val($('input#form_parm1').val()));
	form.appendTo('body').submit().remove();
}

function check_domain_validation() {
	var dvs=$('input.domain_validation_status'),url=dvs.attr('data-url');
	if(dvs.hasClass('red')) {
    var x=$.get(url,'',function(e){
      if(x.status==200){
				var y=dvs.attr('data-otherValue');
				dvs.removeClass('red').addClass('green').attr('data-otherValue',dvs.val()).val(y);
				$('div#check-domain-message').hide();
			}
		});
	}
}

function register_domain() {
  var data = {ajax:'apple_register_domain',processor:$('#processor').val(),domain:$('[name=domain]').val()};
  $.ajax({
  url:'payconfig.cgi',
  data:data,
  dataType:'jsonp',jsonp:'json',success:function(r){
    var d=$('#regDomainResponse');
    if(r.success) {
      d.html(r.message);
      d.removeClass('error');
      var dvs=$('input.domain_registration');
      if(dvs.hasClass('red')){
        var y=dvs.attr('data-otherValue');
        dvs.removeClass('red').addClass('green').attr('data-otherValue',dvs.val()).val(y);
        d.hide();
        $('#domainRegistrationValue').val('checked');
      }
    } else {
      d.html(r.message);
      var dvs=$('input.domain_registration');
      if(dvs.hasClass('green')){
        var y=dvs.attr('data-otherValue');
        dvs.addClass('red').removeClass('green').attr('data-otherValue',dvs.val()).val(y);
        $('#domainRegistrationValue').val('unchecked');
      }
      d.show();
    }
  }
  });
}

$(function() {
	check_domain_validation();
	$(document).on('click','#check-domain-validation',check_domain_validation);
	$(document).on('click','#domain_validation_upload_button',upload_domain_validation_file);
	$(document).on('click','#create_csr_button',create_csr);
	$(document).on('click','#applepay_cert_upload_button',upload_applepay_cert);
	$(document).on('click','#register_domain',register_domain);

	$(document).on('change','#domain_validation_file',function() { $('#domain_validation_upload_button').css({'display':'block'}); });
	$(document).on('change','#applepay_cert',function() { $('#applepay_cert_upload_button').css({'display':'block'}); });
	$(document).on('click','#create_csr_button',function() { $('#download_csr_button').css({'display':'block'}); });

	$(document).on('click','#download_csr_button',download_csr);
});

