ss_jQuery(function($) {
  var state = {
    rating: 0
  }

  if(document.characterSet!='UTF-8')$('input[type=text], textarea:not(:hidden)').change(function(){$(this).val(emojiStrip(this.value))});

  $('.reviews_star').hover(
    function() {
      state.rating = parseInt($(this).prevAll('.current_rating').val());
      var star_num = parseInt($(this).html());
      $(this).prevAll('.reviews_stars_rating').css({
        'width': ((star_num + 1)* 100) / max_stars + '%'
      });
    } ,
    function() {
      $(this).prevAll('.reviews_stars_rating').css({
        'width': state.rating + '%'
      });
    }
  );

  $('.reviews_star').on('click',function() {
    var rating = (parseInt($(this).html()) + 1) / max_stars * 100;
    $(this).prevAll('.current_rating').val(rating);
    $(this).prevAll('.rating').val(rating);
    state.rating = rating;
    $(this).parent().parent().find('.error').remove();
  });

  $('.reviews_submit').on('click',function() {
    var top_form = $(this).closest('form');
    var in_form = 1;
    if (top_form.length == 0) {
      in_form = 0;
      $(this).closest('.reviews_form').wrap('<form id="ser_form"/>');
      top_form = $('#ser_form');
    }
    $(top_form).validate({
      ignore: [],
      errorClass: 'field_warn',
      errorPlacement: function(error, element) {
        if (element.hasClass('rating'))
          element.parent().next().after(error);
        else
          element.next().after(error);
      },
      rules: {
        rating: {
          required: true,
          min: 1
        },
        reviews_area: {
          required: min_length > 0,
          minlength: min_length
        }
      },
      messages: {
        reviews_name: t_name_required,
        reviews_title: t_title_required,
        reviews_email: {
          required: t_email_required,
          email: t_email_wrong
        },
        rating: t_rating_required,
        reviews_area: t_review_length + min_length + t_characters
      }
    });

    if ($(top_form).valid()) {
      var data = 'ajax=submit&' + $(top_form).serialize();
      var url = sb_rev_path + '/reviews.cgi';
      var submit_button = $(this).val();
      $(this).val(t_working);
      $(this).attr('disabled', 'disabled');

      $.ajax({
        type: 'POST',
        url: url,
        data: data,
        success:  function(response) {
          $('.reviews_submit').val(submit_button);
          $('.reviews_submit').removeAttr('disabled');
          if (response.search('CAPTCHA error') == -1) {
            $(top_form).replaceWith(response);
          }
          else {
            $('.captcha_error').css('display', 'block');
            if (captcha_type == 4)
              ACPuzzle.reload('');
            else if (captcha_type == 3)
              Recaptcha.reload();
          }
          if (!in_form)
            $(top_form).find('.reviews_form').unwrap();
        }
      });
    } else {
      $(window).scrollTop($(top_form).offset().top_form-100);
      if (!in_form)
        $(top_form).find('.reviews_form').unwrap();
    }
  });

  $('.reviews_area').bind('paste keydown', function() {
    var text = $(this).val();
    var len = text.length;
    if (len > max_length) {
      $(this).val(text.substr(0, max_length));
      len = max_length;
    }
    $(this).nextAll('.character_count').find('a').html(max_length - len);
  });

  $('.all_reviews').scrollPagination({
    'contentPage': sb_rev_path + '/reviews.cgi',
    'contentData': 'ajax=load&storeid='+$('#storeid').val()+'&rec='+$('#rec').val()+'&GUID='+$('#GUID').val()+'&offset='+ $('.all_reviews').children().length,
    'scrollTarget': $(window),
    'heightOffset': 10,
    'beforeLoad': function(){
      this.contentData = 'ajax=load&storeid='+$('#storeid').val()+'&rec='+$('#rec').val()+'&GUID='+$('#GUID').val()+'&offset='+ $('.all_reviews').children().length;
    },
    'afterLoad': function(elementsLoaded){
      if ($(elementsLoaded).length == 0)
        $('.all_reviews').stopScrollPagination();
    }
  });
});