ss_jQuery(function($) {
  $(document).on('click', '#button_send_test_email', function() {
    var email = $('#test_email_address').val();
    $.ajax({
      type: 'POST',
      url: 'reviews_bo.cgi',
      data: 'ajax=send_test_email&email='+encodeURIComponent(email),
      success:  function(response) {
        alert('Test email sent');
      }
    });
    return false;
  });

  $('#min_length').change(function(e){$('#max_length').valid()});
  $('#max_stars').change(function(e){$('#auto_stars').valid()});

  $('form').validate({
    rules: {
      min_length: {
        required: '#reviews_enable:checked',
        digits: true
      },
      max_length: {
        required: '#reviews_enable:checked',
        digits: true,
        greaterThan: '#min_length'
      },
      max_stars: {
        required: '#reviews_enable:checked',
        digits: true,
        max:20,
        min:1
      },
      auto_stars: {
        required: '#approval-1:checked',
        digits: true,
        lessThanOrEqualTo: '#max_stars'
      },
      email_days: {
        required: '#email_enable',
        digits: true
      },
      summary_best: {
        required: '#summary_enable',
        digits: true
      },
      summary_worst: {
        required: '#summary_enable',
        digits: true
      },
      RV_ss_PageWidth: {
        digits: true
      },
      notify_email: {
        required: '#notify_pending:checked,#notify_approved:checked',
        email: true
      },
      recaptcha_site_key: {
        required: '#reviews_captcha_type-5:checked,#reviews_captcha_type-6:checked'
      },
      recaptcha_secret_key: {
        required: '#reviews_captcha_type-5:checked,#reviews_captcha_type-6:checked'
      }
    },
    errorPlacement: function(error,element) {
      error.css({display:'block'});
      if(element.hasClass('cp_text')) element=element.parent();
      element.parent().append(error);
    },
    messages: {
      max_length: {
        greaterThan: 'Must be larger than minimal length.'
      },
      auto_stars: {
        lessThanOrEqualTo: 'Must not be larger than maximum number of stars.'
      }
    }
  });

  var saved_buyers_captcha=$('#captcha_buyers').prop('checked');
  $('#captcha_buyers').on('change',function(){saved_buyers_captcha=$(this).prop('checked');});
  var saved_captcha_type = $('input[name="reviews_captcha_type"]').val();
  $('input[name="reviews_captcha_type"]').on('change',function() {
    if ($(this).val()!='4') {
      if(saved_captcha_type == 4) {
        $('#recaptcha_config').show();
        $('#type-in-warning').hide();
        $('#captcha_buyers').prop('checked',saved_buyers_captcha).prop('disabled',false);
      }
      saved_captcha_type=$(this).val();
    } else {
      $('#recaptcha_config').hide();
      $('#type-in-warning').show();
      saved_buyers_captcha=$('#captcha_buyers').prop('checked');$('#captcha_buyers').prop('checked',false).   prop('disabled',true);
      saved_captcha_type=$(this).val();
    }
  });

  $('[name=reviews_captcha_type]:checked').change();
});
