function get_ship_params(carrier_id)
{
  var params;
  var i;

  // Collect parameters to be passed to the configuration screen
  // for the selected shipping carrier.

  params = carrier_config[carrier_id];

  with (document.forms[0])
  {
    for (i = 0; i < shipmethod.length; i++)
    {
      if (shipmethod[i].checked == true)
      {
        params += '&shipmethod=' + shipmethod[i].value;
        break;
      }
    }

    for (i = 0; i < selfmt.length; i++)
    {
      if (selfmt[i].checked == true)
      {
        params += '&selfmt=' + selfmt[i].value;
        break;
      }
    }

    if (pro_store)
    {
      if (shipapi.checked == true)
        params += '&shipapi=' + shipapi.value;
    }

    if (ship_order.value.length > 0)
      params += '&ship_order=' + ship_order.value;

    if (ups_active.checked == true)
      params += '&ups_active=1';

    if (fedex_active.checked == true)
      params += '&fedex_active=1';

    if (usps_active.checked == true)
      params += '&usps_active=1';

    if (canada_post_active.checked == true)
      params += '&canada_post_active=1';

    if (australia_post_active.checked == true)
      params += '&australia_post_active=1';
  }

  return params;
}

function configure_carrier(carrier_id, carrier_name)
{
  var params = get_ship_params(carrier_id, carrier_name);
  var config_url;

  config_url = shipping_url + '/' + carrier_name + '.cgi?' + params;
  window.location.href = config_url;
}

function move_ship_item(incr)
{
  var items, text, value;
  var i, j, n;

  with (document.forms[0])
  {
    items = ship_items.options;
    i = ship_items.selectedIndex;
    if (i < 0)
    {
      alert(select_list_item);
      return false;
    }

    j = i + incr;
    n = items.length;

    if ((incr < 0 && j < 0) || (incr > 0 && j >= n))
      return false;

    text = items[j].text;
    value = items[j].value;
    items[j].text = items[i].text;
    items[j].value = items[i].value;
    items[i].text = text;
    items[i].value = value;

    items[i].selected = false;
    items[j].selected = true;

    update_ship_order();
  }

  return false;
}

function include_ship_item(checked, text, name)
{
  var ship_items = document.getElementById('ship_items');
  var items = ship_items.options;
  var i;

  for (i = 0; i < items.length; i++)
  {
    if (items[i].value == name)
      break;
  }

  if (checked)
  {
    if (i == items.length)
      items[i] = new Option(text, name, false, false);
  }
  else
  {
    if (i < items.length)
      items[i] = null;
  }

  update_ship_order();
  get_coupon_shipping_services();
}

function update_ship_order()
{
  var ship_items = document.getElementById('ship_items');
  var ship_order = document.getElementById('ship_order');
  var items = ship_items.options;
  var i;

  ship_order.value = '';

  for (i = 0; i < items.length; i++)
  {
    if (i > 0)
      ship_order.value += '|';
    
    ship_order.value += items[i].value;
  }
}

function add_box_size()
{
  var num_boxes = document.getElementById('standard_box_sizes');
  var num = Number(num_boxes.value);
  var table, input, col, dim, label;
  var i;

  var row = document.createElement('tr');
  var label = document.createElement('td');

  label.innerHTML = 'Box ' + Number(num + 1);
  row.appendChild(label);

  for (i = 0; i < 4; i++)
  {
    switch (i)
    {
      case 0:
        dim = '_length';
        break;

      case 1:
        dim = '_width';
        break;

      case 2:
        dim = '_height';
        break;

      case 3:
        dim = '_desc';
        break;
    }
  
    input = document.createElement('input');
    input.type = 'text';
    input.id = 'size' + num + dim;
    input.name = input.id;

    switch (i)
    {
      case 0:
      case 1:
      case 2:
        input.className = 'number center';
        input.size = '6';
        break;

      case 3:
        input.className = 'text';
        input.size = '40';
        break;
    }

    col = document.createElement('td');
    col.appendChild(input);
    row.appendChild(col);
  }

  table = document.getElementById('box_sizes');
  table.appendChild(row);

  num_boxes.value = Number(num + 1);
  return false;
}

function validate_box_sizes()
{
  var num_boxes = document.getElementById('standard_box_sizes');
  var num = Number(num_boxes.value);
  var length, width, height;
  var i;

  for (i = 0; i < num; i++)
  {
    var l = document.getElementById('size' + i + '_length');
    var w = document.getElementById('size' + i + '_width');
    var h = document.getElementById('size' + i + '_height');

    length = l.value.replace(',', '.');
    width  = w.value.replace(',', '.');
    height = h.value.replace(',', '.');

    if (isNaN(length))
    {
      l.focus();
      alert(length_not_a_number);
      return false;
    }

    if (isNaN(width))
    {
      w.focus();
      alert(width_not_a_number);
      return false;
    }

    if (isNaN(height))
    {
      h.focus();
      alert(height_not_a_number);
      return false;
    }

    length = Number(length);
    width  = Number(width);
    height = Number(height);

    if (l.value.length > 0 || w.value.length > 0 || h.value.length > 0)
    {
      if (l.value.length == 0)
      {
        alert(enter_length_dimension);
        l.focus();
        return false;
      }
    
      if (w.value.length == 0)
      {
        alert(enter_width_dimension);
        w.focus();
        return false;
      }

      if (h.value.length == 0)
      {
        alert(enter_height_dimension);
        h.focus();
        return false;
      }

      if (length <= 0)
      {
        alert(invalid_dimension);
        l.focus();
        return false;
      }

      if (width <= 0)
      {
        alert(invalid_dimension);
        w.focus();
        return false;
      }

      if (height <= 0)
      {
        alert(invalid_dimension);
        h.focus();
        return false;
      }

      if (length < width || length < height)
      {
        alert(dimensions_warning);
        l.focus();
        return false;
      }
    }
  }

  return true;
}

function clear_box_sizes()
{
  var num_boxes = document.getElementById('standard_box_sizes');
  var num = Number(num_boxes.value);
  var i;

  for (i = 0; i < num; i++)
  {
    var l = document.getElementById('size' + i + '_length');
    var w = document.getElementById('size' + i + '_width');
    var h = document.getElementById('size' + i + '_height');

    l.value = '';
    w.value = '';
    h.value = '';
  }

  return false;
}

function validate_shipping_choices()
{
  if (validate_box_sizes() == false)
    return false;

  // If the failsafe option is checked, verify that a shipping method
  // has been selected for it.
  if (document.getElementsByName('no_shipping_service')[2].checked)
  {
    var method = document.getElementById('failsafe_ship_method');
    if (method.selectedIndex <= 0)
    {
      alert(select_failsafe_method);
      method.focus();
      return false;
    }
  }

  return true;
}

function method_selected(config)
{
  if (config.name.indexOf('failsafe') >= 0)
  {
    var method = document.getElementById('failsafe_ship_method');
    if (method.selectedIndex <= 0)
    {
      alert(select_shipping_rate);
      method.focus();
      return false;
    }
  }
  else
  {
    var choices = document.getElementsByName('shipmethod');
    var i = choices.length;

    if (choices[i-1].checked)
    {
      alert(select_shipping_rate);
      return false;
    }
  }

  return true;
}

function failsafe_selected()
{
  if (document.getElementById('failsafe_ship_method').selectedIndex > 0)
    document.getElementsByName('no_shipping_service')[2].checked = true;
}

var xmlHttp = null;

function GetXmlHttpObject()
{
  try
  {
    xmlHttp = new XMLHttpRequest();
  }
  catch(e)
  {
    try
    {
      xmlHttp = new ActiveXObject("MSXML2.XMLHTTP");
    }
    catch(e)
    {
      xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
  }

  return xmlHttp;
}

function get_coupon_shipping_services()
{
  var url = shipping_url + '/shipping.cgi?get_coupon_shipping_services=1';
  var ship_order = document.getElementById('ship_order');
  var services = ship_order.value.split('|');
  var i;

  for (i = 0; i < services.length; i++)
  {
    switch (services[i])
    {
      case 'ss':
        url += '&ss=1';
        break;

      case 'api':
        url += '&api=1';
        break;

      case 'ups':
        url += '&ups=1';
        break;

      case 'usps':
        url += '&usps=1';
        break;

      case 'fedex':
        url += '&fedex=1';
        break;

      case 'canada_post':
        url += '&canada=1';
        break;

      case 'australia_post':
        url += '&australia=1';
        break;

      case 'shopex':
        url += '&shopex=1';
        break;
    }
  }

  url += "&sid=" + Math.random();

  xmlHttp = GetXmlHttpObject();
  xmlHttp.onreadystatechange = list_shipping_services;
  xmlHttp.open("GET", url, true); // asynchronous
  xmlHttp.send(null);
}

var coupon_service_warning = false;

function list_shipping_services()
{
  if (xmlHttp.readyState == 4 || xmlHttp.readyState == 'complete')
  {
    var response = xmlHttp.responseText;
    var services_div = document.getElementById('services_div');
    var services_list = document.getElementById('coupon_service');
    var no_services_div = document.getElementById('no_services_div');
    var free_coupon_service = document.getElementById('free_coupon_service');
    var coupon_service_valid = false;
   
    services_list.options.length = 0;

    if (response.length > 0)
    {
      var services = response.split('\n');
      var service, name, value, selected;
      var i, j = 0, k = 0;

      services_list[j++] = new Option(select_service, '', false, false);

      for (i = 0; i < services.length; i++)
      {
        service = services[i].split('|');

        name = service[0];
        value = service[1];
        selected = service[2];

        if (name.length > 0)
        {
          if (selected.indexOf('yes') == 0)
            k = j;

          if (coupon_service.length > 0 && value == coupon_service)
            coupon_service_valid = true;

          name = name.replace(/&#174;/g, ' ');
          services_list[j++] = new Option(name, value, false, false);
        }
      }

      services_list.selectedIndex = k;
      services_div.style.display = '';
      no_services_div.style.display = 'none';
    }
    else
    {
      services_div.style.display = 'none';
      no_services_div.style.display = '';
    }

    if (coupon_service.length > 0 && coupon_service_valid == false)
    {
      if (coupon_service_warning == false)
      {
        var msg = coupon_service_invalid;
        var move_to = null;
        
        if (response.length > 0)
        {
          msg += '  ' + select_another_service;
          move_to = services_list;
        }

        if (free_coupon_service.checked)
        {
          alert(msg);

          if (move_to != null)
            move_to.focus();

          // warn only once
          coupon_service_warning = true;
        }
      }
    }
  }
}

function check_coupon_services()
{
  var services_list = document.getElementById('coupon_service');
  var free_coupon_service = document.getElementById('free_coupon_service');

  if (free_coupon_service.checked)
  {
    if (services_list.options.length == 0)
    {
      var msg = warning + ': ';
      msg += no_shipping_services + '  ';
      msg += continue_anyway;
      
      if (confirm(msg) == false)
        free_coupon_service.checked = false;
    }
  }
}

