
function check_usps_config()
{
  if (check_weight('usps_max_pkg_weight') == false)
    return false;

  if (check_weight('usps_min_weight', 'usps_use_min_weight') == false)
    return false;

  if (check_weight('usps_min_order_weight', 'usps_use_min_order_weight') == false)
    return false;

  if (check_weight('usps_max_weight', 'usps_use_max_weight') == false)
    return false;

  if (check_weight('usps_max_weight') == false)
    return false;

  if (check_weight_limit('usps_max_weight', '70.0') == false)
    return false;

  if (check_rate_percent('usps_commercial_rate_adjust') == false)
    return false;

  if (check_rate_percent('usps_retail_rate_adjust') == false)
    return false;

  if (check_rate_percent('usps_international_rate_adjust') == false)
    return false;

  if (check_max_pkg_size() == false)
    return false;

  if (check_reserve_pkg_size() == false)
    return false;

  if (check_min_item_size() == false)
    return false;

  return true;
}

function check_weight(weight_id, use_id)
{
  var weight_elem = document.getElementById(weight_id);
  var weight_entered = weight_elem.value.length > 0;

  if (arguments.length > 1)
  {
    if (document.getElementById(use_id).checked)
    {
      if (!weight_entered)
      {
        weight_elem.focus();
        alert(enter_weight);
        return false;
      }
    }
  }

  if (isNaN(weight_elem.value))
  {
    weight_elem.focus();
    alert(weight_not_a_number);
    return false;
  }

  if (weight_entered && parseFloat(weight_elem.value) <= 0.0)
  {
    weight_elem.focus();
    alert(invalid_weight);
    return false;
  }

  return true;
}

function check_weight_limit(weight_id, limit)
{
  var weight_elem = document.getElementById(weight_id);
  var weight = parseFloat(weight_elem.value);

  if (weight > parseFloat(limit))
  {
    weight_elem.focus();
    alert(weight_over_limit);
    return false;
  }

  return true;
}

function check_rate_percent(percent_id)
{
  var percent_elem = document.getElementById(percent_id);
  var percent = percent_elem.value;

  if (percent.length > 0)
  {
    percent = parseFloat(percent);
    if (isNaN(percent))
    {
      percent_elem.focus();
      alert(percent_not_a_number);
      return false;
    }
  }

  return true;
}

function check_max_pkg_size()
{
  var l = document.getElementById('usps_max_pkg_length');
  var w = document.getElementById('usps_max_pkg_width');
  var h = document.getElementById('usps_max_pkg_height');

  return check_dimensions(l, w, h);
}  

function check_reserve_pkg_size()
{
  var l = document.getElementById('usps_packing_material_length');
  var w = document.getElementById('usps_packing_material_width');
  var h = document.getElementById('usps_packing_material_height');

  return check_dimensions(l, w, h);
}  

function check_min_item_size()
{
  var l = document.getElementById('usps_min_item_length');
  var w = document.getElementById('usps_min_item_width');
  var h = document.getElementById('usps_min_item_height');

  if (document.getElementById('usps_use_min_item_size').checked)
  {
    if (l.value.length == 0 && w.value.length == 0 && h.value.length == 0)
    {
      l.focus();
      alert(enter_dimensions);
      return false;
    }
  }

  return check_dimensions(l, w, h);
}  

